#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <winuser.h>

#include <assert.h>

HINSTANCE hModule0;
HWND hwnd0;

HWND hwndTdy[0xff];
int	fHistory;

LRESULT CALLBACK TeddyHouseProc (HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK EnumWindowsProc_ListUp(HWND hwnd, LPARAM lParam);

BOOL InitializeApp();
VOID APIENTRY HandlePopupMenuRight (HWND   hwnd, POINT point);
VOID APIENTRY HandlePopupMenuLeft (HWND   hwnd, POINT point);
BOOL TrayMessage (HWND hwnd, DWORD dwMessage, UINT uID, HICON hIcon, PSTR pszTip );

void NotifyAdd (HWND hwnd, UINT uIndex);
void NotifyDelete (HWND hwnd, UINT uIndex);

int WINAPI WinMain (HINSTANCE /*hInstance*/, HINSTANCE /*hPrevInstance*/, LPSTR /*lpCmdLine*/, int /*nCmdShow*/ )
{
	pSend=NULL;
	nTdy=0;

	MSG msg;
	hModule0 = GetModuleHandle(NULL);
	if (! InitializeApp()) return -1;

	while (GetMessage(&msg, NULL, 0, 0))    
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam; 
}

BOOL InitializeApp() 
{
	if(FindWindow("TeddyHouseClass", "TeddyHouse"))return FALSE;

	WNDCLASS wc;
	wc.style            = 0;
	wc.lpfnWndProc      = TeddyHouseProc;
	wc.cbClsExtra       = 0;
	wc.cbWndExtra       = 0;
	wc.hInstance        = hModule0; 
//	wc.hIcon            = LoadIcon(NULL,MAKEINTRESOURCE(IDI_ICON1));

//	wc.hIcon = (HICON)LoadImage(hModule0, MAKEINTRESOURCE(IDI_ICON1), IMAGE_ICON,
//			     16, 16, 0);
	wc.hIcon=NULL;
	wc.hCursor          = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground    = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName     = NULL;
	wc.lpszClassName    = "TeddyHouseClass";
 
	if (! RegisterClass(&wc))
		return FALSE;

	hwnd0 = CreateWindow("TeddyHouseClass", "TeddyHouse", WS_OVERLAPPED,	 //WS_POPUP,
			0,0, 
			200, 200, NULL, NULL, hModule0, NULL); 
	if (!hwnd0)return FALSE;  

	//s
	{
		char* p1=Restore("SOFTWARE\\Him\\Teddy\\.Config\\","AutoRun");
		if(p1 && atoi(p1)==1){
			char* p2=Restore("SOFTWARE\\Him\\Teddy\\.Config\\","AutoFile");
			if(p2 && *p2){
				int n=lstrlen(p2)+sizeof("Teddy \"\"");
				char* p3=new char[n+1];
				*p3=0;
				lstrcat(p3,"Teddy \"");
				lstrcat(p3,p2);
				lstrcat(p3,"\"");
				Exe(p3);
			}
			delete []p2;
		}
		delete []p1;
	}

	return TRUE;
} 

BOOL IsTdy(HWND hwnd)
{
	char TdyName[] = TEDDY_CLASS_NAME;
	char AppName[sizeof(TdyName)];

	if(! GetClassName(hwnd, AppName, sizeof(TdyName))){
		return FALSE;
	}
	char c;
	int i=0;
	while((c=TdyName[i])!=0){
		if(c!=AppName[i]){
			return FALSE;
		}
		i++;
	}
	return TRUE;
}

LRESULT  CALLBACK TeddyHouseProc ( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
    case WM_CREATE:
		{
			HWND hwndOwner;
			RECT rc, rcDlg, rcOwner;

			hwndOwner = GetDesktopWindow();
			GetWindowRect(hwndOwner, &rcOwner);
			GetWindowRect(hwnd, &rcDlg);
			CopyRect(&rc, &rcOwner);

			OffsetRect(&rcDlg, -rcDlg.left, -rcDlg.top);
			OffsetRect(&rc, -rc.left, -rc.top);
			OffsetRect(&rc, -rcDlg.right, -rcDlg.bottom);

			SetWindowPos(hwnd,
				HWND_TOP,
				rcOwner.left + (rc.right / 2),
				rcOwner.top + (rc.bottom / 2),
				0, 0,
				SWP_NOSIZE);

			NotifyAdd(hwnd, 0);

		}
		return 0;

    case WM_COPYDATA:
		{
			PCOPYDATASTRUCT pcds=(PCOPYDATASTRUCT)lParam;
			switch(pcds->dwData){
			case REQUEST_AND_SEND_TITLE:
			case REQUEST_AND_SEND_UNIQUENAME:
			
				assert(pSend==NULL);
				pSend=NULL;
				nSend=pcds->cbData;
				if(pcds->lpData==NULL || nSend<=0 || nSend>=SEND_DATA_MAX_SIZE){
					pSend=NULL;
				} else {
					pSend=new char[nSend];
					char*pSrc=(char*)(pcds->lpData);
					char*pDst=pSend;
					for(int i=0;i<nSend;i++){
						*pDst++=*pSrc++;
					}
				}
				return TRUE;

			default:;
			}
		}
		return FALSE;

    case WM_DESTROY:	
		NotifyDelete(hwnd, 0);
		PostQuitMessage(0);
		return 0;

    case WM_COMMAND:
		switch (GET_WM_COMMAND_ID(wParam, lParam))
		{
		case IDCANCEL:
			SendMessage(hwnd,WM_CLOSE,0,0L);
			break;

		case TDM_CLOSEALL:   
			EnumWindows((WNDENUMPROC)EnumWindowsProc_AllClose, NULL);
			break;

		case TDM_OPENTEDDY:		Exe("Teddy");		break;
		case TDM_OPENPROPERTY:	Exe("Teddy /p");	break;

		default:
			{
				int n=GET_WM_COMMAND_ID(wParam, lParam)-TDM_TDY;
				if(0x100>n && n>=0){
					if(fHistory){
						char lpszFileNo[]="FILE00";
						lpszFileNo[4]=(char)('0'+n/10);
						lpszFileNo[5]=(char)('0'+n%10);
						char* lpszFile=Restore("SOFTWARE\\Him\\Teddy\\.History\\",lpszFileNo);
						char* pExe=new char[lstrlen(lpszFile)+sizeof("Teddy.exe")+3];

						char* pDst=pExe;

						char* pSrc="Teddy.exe";
						while(*pSrc){
							*pDst++=*pSrc++;
						}
						
						*pDst++=' ';
						*pDst++='"';
						
						pSrc=lpszFile;
						while(*pSrc){
							*pDst++=*pSrc++;
						}
						
						*pDst++='"';
						*pDst++=NULL;
						
						delete[]lpszFile;
						{
							STARTUPINFO si={0};
							PROCESS_INFORMATION pi;
							si.cb=sizeof(STARTUPINFO);
							if(!CreateProcess(NULL,pExe,NULL,NULL,FALSE,0,NULL,NULL,&si,&pi)){
								// s
							}
						}
						delete[]pExe;
					} else {
						PostMessage(hwndTdy[n],WM_CLOSE,0,0);
					}
				}
			break;
			}
//			nNewMode = GET_WM_COMMAND_ID(wParam, lParam) - (MYWM_NOTIFYICON + 10);
		}
		return 0;

    case WM_USER_NOTIFYICON:
		switch (lParam)
		{

//	    case WM_LBUTTONDBLCLK:
//			PostMessage(hwnd, WM_COMMAND,MAKELONG(TDM_OPENTEDDY,0),0);
//			break;

	    case WM_LBUTTONDOWN:
			{
				 POINT point;
 				 GetCursorPos (&point);
				 HandlePopupMenuLeft (hwnd, point);
				 break;
			}
	    
	    case WM_RBUTTONDOWN:
			{
				 POINT point;
				 GetCursorPos (&point);
				 HandlePopupMenuRight (hwnd, point);
				 break;
			}

		default:
			break;

		}
		return 0;

    default:
		break;
    
    }

    return DefWindowProc(hwnd, uMsg, wParam, lParam); 
}

BOOL TrayMessage ( HWND hwnd,  DWORD dwMessage,  UINT uID,  HICON hIcon,  PSTR pszTip )
{
    BOOL res;
    NOTIFYICONDATA tnd;

    hIcon = (HICON)LoadImage(hModule0, MAKEINTRESOURCE(IDI_ICON1), IMAGE_ICON,
			     16, 16, 0);
    
    tnd.cbSize		= sizeof(NOTIFYICONDATA);
    tnd.hWnd		= hwnd;
    tnd.uID			= uID;
    tnd.uFlags		= NIF_MESSAGE|NIF_ICON|NIF_TIP;
    tnd.uCallbackMessage= WM_USER_NOTIFYICON;
    tnd.hIcon		= hIcon;

	if (pszTip){
		lstrcpyn(tnd.szTip, pszTip, sizeof(tnd.szTip));
    }else{
		lstrcpyn(tnd.szTip, "TeddyHouse", sizeof("TeddyHouse"));;
    }

    res = Shell_NotifyIcon(dwMessage, &tnd);

    if (hIcon){
		DestroyIcon(hIcon);
    }
    return res;
}


void NotifyDelete ( HWND hwnd,  UINT uIndex )
{
    TrayMessage(hwnd, NIM_DELETE, uIndex, NULL, NULL);
}


void NotifyAdd ( HWND hwnd,  UINT uIndex )
{
    TrayMessage(hwnd, NIM_ADD, uIndex, NULL, NULL);
}

VOID APIENTRY HandlePopupMenuRight ( HWND  hwnd, POINT point)
{
	HMENU hMenu = CreatePopupMenu(); 
	HMENU hMenu2 = CreatePopupMenu(); 

	if(!hMenu || !hMenu2)return ;

	nTdy=0;
	fHistory=FALSE;
	EnumWindows((WNDENUMPROC)EnumWindowsProc_ListUp, (LPARAM)hMenu2);

	AppendMenu (hMenu, MF_POPUP|MF_STRING|(nTdy?0:MF_GRAYED), (UINT)hMenu2, "ANZTI");
    AppendMenu (hMenu, MF_STRING|(nTdy?0:MF_GRAYED), TDM_CLOSEALL, "SANZTI");
	AppendMenu (hMenu, MF_SEPARATOR, 0, NULL);
    AppendMenu (hMenu, MF_STRING, TDM_OPENPROPERTY, "ݒ");
	AppendMenu (hMenu, MF_SEPARATOR, 0, NULL);
    AppendMenu (hMenu, MF_STRING, IDCANCEL, "Teddy's House I");

	SetForegroundWindow (hwnd);
    TrackPopupMenu (hMenu, TPM_BOTTOMALIGN, point.x, point.y, 0, hwnd, NULL);
    PostMessage (hwnd, WM_USER, 0, 0);
	DestroyMenu(hMenu2);
	DestroyMenu(hMenu);
}

VOID APIENTRY HandlePopupMenuLeft ( HWND  hwnd, POINT point)
{
	HMENU hMenu = CreatePopupMenu(); 
	if(!hMenu)return ;

	fHistory=TRUE;

    AppendMenu (hMenu, MF_STRING, TDM_OPENTEDDY, "J");
	AppendMenu (hMenu, MF_SEPARATOR, 0, NULL);

	char* lpszTitle[MAXHISTORY];
	for(int i=0;i<MAXHISTORY;i++){
		lpszTitle[i]=NULL;
	}
	for(i=0;i<MAXHISTORY;i++){
		int nNo=i;
		char lpszTitleNo[]="TITLE00";
		lpszTitleNo[5]=(char)('0'+nNo/10);
		lpszTitleNo[6]=(char)('0'+nNo%10);
		lpszTitle[i]=Restore("SOFTWARE\\Him\\Teddy\\.History\\",lpszTitleNo);
		if(lpszTitle[i] && (*lpszTitle[i])){
			AppendMenu (hMenu, MF_STRING, TDM_TDY+nNo,lpszTitle[i]);
		}
	}
	SetForegroundWindow (hwnd);
    TrackPopupMenu (hMenu, TPM_BOTTOMALIGN, point.x, point.y, 0, hwnd, NULL);
	PostMessage (hwnd, WM_USER, 0, 0);

	for(i=0;i<MAXHISTORY;i++){
		delete[](lpszTitle[i]);
	}
	DestroyMenu(hMenu);
}

BOOL CALLBACK EnumWindowsProc_ListUp(HWND hwnd, LPARAM lParam)
{
    HMENU hMenu=(HMENU)lParam;
	if(IsTdy(hwnd) && nTdy<0xff){
//		if(!SendMessage(hwnd,WM_USER_PLEASE_SEND,(WPARAM)hwnd0,(LPARAM)REQUEST_AND_SEND_TITLE))return TRUE; // Ԑt
		if(GetWindowLong(hwnd, GWL_EXSTYLE) & WS_EX_TOOLWINDOW)return TRUE;

		hwndTdy[nTdy]=hwnd;
		int n=GetWindowTextLength(hwnd);
		if(n){
			char* p=new char[n+1+1];
			GetWindowText(hwnd,p,n+1);
			*(p+n+1)=0;
			AppendMenu (hMenu, MF_STRING, TDM_TDY+nTdy++,p);
			delete []p;
		} else {
			AppendMenu (hMenu, MF_STRING, TDM_TDY+nTdy++,"(Unknown)");
		}
	}
	return TRUE;
}

BOOL CALLBACK EnumWindowsProc_AllClose(HWND hwnd, LPARAM /*lParam*/)
{
	if(IsTdy(hwnd)){
		PostMessage(hwnd,WM_CLOSE,0,0);
	}
	return TRUE;
}

BOOL CALLBACK EnumWindowsProc_ReloadDll(HWND hwnd, LPARAM /*lParam*/)
{
	if(IsTdy(hwnd)){
		PostMessage(hwnd,WM_USER_RELOAD_DLL,0,0);
	}
	return TRUE;
}

char* Restore(char* strEntry, char* strKey)
{
	char* p=NULL;
	if(!strEntry || !strKey)return p;

	DWORD Status ;
	HKEY hKeyNames = 0 ;
	{
		Status = RegOpenKeyEx(HKEY_CURRENT_USER ,strEntry, 0L, KEY_READ, &hKeyNames);
		if (Status != ERROR_SUCCESS){
			goto Close;
		}
		DWORD size;
		DWORD Type=REG_SZ;
		Status = RegQueryValueEx(hKeyNames, strKey, NULL, &Type, NULL, &size);
		if (Status != ERROR_SUCCESS){
			goto Close;
		}
		p=new char[size];
		Status = RegQueryValueEx(hKeyNames, strKey, NULL, &Type, (unsigned char*)p, &size);
		if (Status != ERROR_SUCCESS){
			p=NULL;
		}
	}
Close:
	RegCloseKey(hKeyNames);
	return p;
}

void Store(char* strEntry, char* strKey, char* strItem)
{
	if(!strEntry || !strKey)return;

	DWORD Status ;
	HKEY hKeyNames = 0 ;
	{
		TCHAR ObjectType [2] ;
		ObjectType [0] = ' ' ;
		ObjectType [1] = '\0' ;
		DWORD dwDisposition ;
		Status = RegCreateKeyEx(HKEY_CURRENT_USER ,strEntry, 0L,
				ObjectType, REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hKeyNames, &dwDisposition);
		if (Status != ERROR_SUCCESS){
			goto Close;
		}
		DWORD Type=REG_SZ;
		Status = RegSetValueEx(hKeyNames, strKey, NULL, Type, (const unsigned char * )(LPCTSTR )strItem, lstrlen(strItem)+1);
		if (Status != ERROR_SUCCESS){
			goto Close;
		}
	}
Close:
	RegCloseKey(hKeyNames);
}